=== debian/changelog ===
glvis (4.3-3) unstable; urgency=medium

  * d/rules: fix $(DEBARCH).
  * d/control: add missing build-depends: xxd, libopengl-dev, libglx-dev,
    libgl-dev, libsdl2-dev, libglew-dev, libglm-dev, libfreetype-dev,
    libfontconfig-dev.

 -- Alex Myczko <tar@debian.org>  Thu, 27 Feb 2025 12:30:28 +0000

glvis (4.3-2) unstable; urgency=medium

  * d/control: add libmfem-dev to build-depends. (Closes: #1085056)

 -- Alex Myczko <tar@debian.org>  Wed, 16 Oct 2024 20:37:07 +0000

glvis (4.3-1) unstable; urgency=medium

  * Initial release. (Closes: #1034901)

 -- Alex Myczko <tar@debian.org>  Fri, 13 Sep 2024 07:55:27 +0000
