=== debian/control ===
Source: glvis
Section: science
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libgl2ps-dev,
 libmfem-dev,
 libopengl-dev,
 libglx-dev,
 libgl-dev,
 libsdl2-dev,
 libglew-dev,
 libglm-dev,
 libfreetype-dev,
 libfontconfig-dev,
 patchelf,
 xxd,
Standards-Version: 4.7.0
Homepage: https://github.com/GLVis/glvis
Vcs-Browser: https://salsa.debian.org/debian/glvis
Vcs-Git: https://salsa.debian.org/debian/glvis.git

Package: glvis
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: accurate and flexible finite element visualization
 This is an OpenGL tool for visualization of finite element meshes and
 functions.
