=== debian/changelog ===
glvis (4.3.2-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Tue, 04 Mar 2025 08:38:52 +0000
