## glvis 4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2024, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #
@@ -167,6 +167,8 @@
   list(APPEND CMAKE_PREFIX_PATH "../glew")
   find_package(GLEW REQUIRED)
   list(APPEND _glvis_libraries GLEW::GLEW)
+  # See https://github.com/nigels-com/glew/issues/192
+  list(APPEND _glvis_compile_defs "GLEW_NO_GLU")
 
   # Find 'glm' which is not part of the CMake standard modules
   list(APPEND GLM_DIR "../glm")
@@ -358,7 +360,3 @@
 
 endif(NOT EMSCRIPTEN)
 
-if(ENABLE_TESTS)
-  enable_testing()
-  add_subdirectory(tests)
-endif(ENABLE_TESTS)
