=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2024, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #
@@ -40,6 +40,7 @@
     "mobius-strip"
     "navier"
     "quad"
+    "quadrature-1D"
     "quadrature-lor"
     "remhos"
     "shaper"
@@ -61,10 +62,10 @@
       COMMAND ${CMAKE_COMMAND} -E make_directory
         ${CMAKE_CURRENT_SOURCE_DIR}/data/baselines/local
       COMMAND ${CMAKE_COMMAND} -E copy
-        ${CMAKE_CURRENT_BINARY_DIR}/test.${test_name}.saved.png
+        ${CMAKE_CURRENT_BINARY_DIR}/test.${test_name}.png
         ${CMAKE_CURRENT_SOURCE_DIR}/data/baselines/local
       DEPENDS
-        ${CMAKE_CURRENT_BINARY_DIR}/test.${test_name}.saved.png
+        ${CMAKE_CURRENT_BINARY_DIR}/test.${test_name}.png
       VERBATIM)
 
   add_dependencies(rebaseline _rebaseline_stream_${test_name})
