=== tests/requirements.txt ===
scikit-image
plotly
numpy >= 1.20.0, < 2.0.0
