=== debian/changelog ===
glvis (4.4-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.7.2.
  * d/copyright: bump years.

 -- Alex Myczko <tar@debian.org>  Fri, 05 Sep 2025 16:05:00 -0500
