=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  libfontconfig-dev,
  patchelf,
  xxd,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/GLVis/glvis
 Vcs-Browser: https://salsa.debian.org/debian/glvis
 Vcs-Git: https://salsa.debian.org/debian/glvis.git
