=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

DEBARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DMFEM_DIR=/usr/include/mfem \
	    -Dmfem_DIR=/usr/lib/$(DEBARCH)/cmake/mfem \
	    -DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF \
	    -DCMAKE_INSTALL_RPATH="" \
#	    -Dmfem_DIR=/usr/lib/cmake/mfem
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

override_dh_auto_install:
	@echo broken

override_dh_fixperms:
	dh_fixperms
	patchelf --remove-rpath debian/glvis/usr/bin/glvis

override_dh_dwz:
	@echo broken
