## glvis 4.4+git20251225+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 # introduced.
 cmake_minimum_required(VERSION 3.10)
 
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
