=== debian/changelog ===
glvis (4.4+git20251225+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Alex Myczko <tar@debian.org>  Fri, 26 Dec 2025 14:04:37 +0000

glvis (4.4+git20251225+ds-1) experimental; urgency=medium

  * New upstream version. (Closes: #1123608)

 -- Alex Myczko <tar@debian.org>  Thu, 25 Dec 2025 14:31:01 +0000

glvis (4.4-2) unstable; urgency=medium

  * d/watch: defined and updated to version 5.

 -- Alex Myczko <tar@debian.org>  Tue, 16 Dec 2025 18:18:04 +0000
