=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,7 @@
 
 %:
 	dh $@ --buildsystem=cmake
+# --no-parallel
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
