## glvis 4.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2026, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #
@@ -23,6 +23,16 @@
 endif ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
 
 project(glvis NONE)
+
+# Load user settings
+set(USER_CONFIG "${CMAKE_CURRENT_SOURCE_DIR}/user.cmake" CACHE PATH
+  "User configuration file. This file is not part of the GLVis source code and
+   is not distributed with GLVis. It can be used to set user-specific options,
+   such as paths to external libraries, compiler flags, etc.")
+include("${USER_CONFIG}" OPTIONAL RESULT_VARIABLE USER_CONFIG_LOADED)
+if (USER_CONFIG_LOADED)
+  message(STATUS "USER_CONFIG = ${USER_CONFIG} (LOADED)")
+endif()
 
 # Import MFEM. The following variables can be used to help CMake find MFEM:
 #  * MFEM_DIR - absolute path to the MFEM build or install prefix.
@@ -57,6 +67,14 @@
 option(GLVIS_USE_LIBPNG
   "Use libpng for taking screenshots internally"
   ON)
+
+option(GLVIS_USE_EGL
+  "Use EGL for headless rendering"
+  OFF)
+
+option(GLVIS_USE_CGL
+  "Use CGL for headless rendering"
+  APPLE)
 
 #
 # Handle a few other definitions
@@ -227,6 +245,23 @@
     message(FATAL_ERROR "Fontconfig not found.")
   endif (FONTCONFIG_LIBRARY)
 
+  # Find EGL
+  if (GLVIS_USE_EGL)
+    find_package(OpenGL OPTIONAL_COMPONENTS EGL)
+    if (OpenGL_EGL_FOUND)
+      list(APPEND _glvis_compile_defs "GLVIS_USE_EGL")
+      list(APPEND _glvis_libraries OpenGL::EGL)
+    else()
+      message(WARNING "EGL library not found. EGL disabled.")
+      set(GLVIS_USE_EGL OFF)
+    endif (OpenGL_EGL_FOUND)
+  endif (GLVIS_USE_EGL)
+
+  # Find CGL
+  if (GLVIS_USE_CGL AND NOT EMSCRIPTEN)
+    list(APPEND _glvis_compile_defs "GLVIS_USE_CGL")
+  endif (GLVIS_USE_CGL AND NOT EMSCRIPTEN)
+
   # Find threading library
   find_package(Threads REQUIRED)
   list(APPEND _glvis_libraries "${CMAKE_THREAD_LIBS_INIT}")
@@ -327,36 +362,3 @@
   if (APPLE)
     set(GLVIS_APP_ICON ${CMAKE_CURRENT_SOURCE_DIR}/share/GLVis.icns)
     set(GLVIS_APP_CREDITS ${CMAKE_CURRENT_SOURCE_DIR}/share/Credits.rtf)
-    set_source_files_properties(
-      ${GLVIS_APP_ICON} ${GLVIS_APP_CREDITS}
-      PROPERTIES
-        MACOSX_PACKAGE_LOCATION "Resources")
-
-    add_executable(app MACOSX_BUNDLE glvis.cpp
-      ${GLVIS_APP_ICON} ${GLVIS_APP_CREDITS})
-    set_target_properties(app
-      PROPERTIES
-        EXCLUDE_FROM_ALL TRUE
-        OUTPUT_NAME GLVis
-        MACOSX_BUNDLE_INFO_PLIST
-          ${CMAKE_CURRENT_SOURCE_DIR}/share/Info.cmake.plist.in)
-    target_link_libraries(app PRIVATE glvis glvis_logo)
-    install(TARGETS app
-      RUNTIME DESTINATION .
-      BUNDLE DESTINATION .)
-    install(CODE [[
-      include (BundleUtilities)
-      fixup_bundle("${CMAKE_INSTALL_PREFIX}/GLVis.app" "" "")
-      file(GLOB LIBS_TO_SIGN
-          "${CMAKE_INSTALL_PREFIX}/GLVis.app/Contents/Frameworks/*.dylib")
-      foreach(LIB ${LIBS_TO_SIGN})
-        if (NOT IS_SYMLINK ${LIB})
-          execute_process(COMMAND codesign --force --sign - ${LIB})
-        endif()
-      endforeach()
-      execute_process(COMMAND codesign --force --sign - ${CMAKE_INSTALL_PREFIX}/GLVis.app)
-    ]] COMPONENT RUNTIME)
-  endif(APPLE)
-
-endif(NOT EMSCRIPTEN)
-
