=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2010-2025, Lawrence Livermore National Security, LLC. Produced
+# Copyright (c) 2010-2026, Lawrence Livermore National Security, LLC. Produced
 # at the Lawrence Livermore National Laboratory. All Rights reserved. See files
 # LICENSE and NOTICE for details. LLNL-CODE-443271.
 #
@@ -31,7 +31,10 @@
     "ex27"
     "ex3"
     "ex5"
+    "ex6-dofs-numbering"
     "ex9"
+    "ex22-scalar"
+    "ex22-vector"
     "klein-bottle"
     "laghos"
     "mesh-explorer"
