=== debian/changelog ===
glvis (4.5-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.

 -- Alex Myczko <tar@debian.org>  Sun, 08 Feb 2026 10:28:54 +0100
