=== debian/watch ===
Version: 5

# GitHub hosted projects.
Template: Github
Owner: GLVis
Project: glvis
